program tri_matrice
  implicit none
  integer, parameter   :: n=10, m=3
  real, dimension(n,m) :: mat
  integer              :: i, j
  character(len=8)     :: format="(  F7.3)"

  write( format(2:3), '(i2)' ) m
  ! Lecture de la matrice  trier.
  open( unit=1,              &
        file="exo6.matrice", &
        form="unformatted",  &
        status="old",        &
        action="read" )
  read( unit=1 ) mat
  close( unit=1 )

  call tri( mat, n, m ) ! Tri de la matrice lue.

 ! criture de la matrice trie.
  open( unit=1,           file="exo11.matrice_triee", &
        form="formatted", status="replace",           &
        action="write" )
  write( unit=1, fmt=format ) ((mat(i,j),j=1,m),i=1,n)
  close( unit=1 )
end program tri_matrice

                   ! Procdure de tri.
subroutine tri( mat, n, m )
  implicit none
  integer              :: n, m
  real, dimension(n,m) :: mat
  integer              :: ligne, col

  do ligne=1,n      ! Tri des lignes.
    call tri_vecteur( mat(ligne,:), m )
  end do
  do col=1,m        ! Tri des colonnes.
    call tri_vecteur( mat(:,col), n )
  end do
  contains
              ! Procdure de tri d'un vecteur.
  subroutine tri_vecteur( v, n )
    integer            :: n, i
    real, dimension(n) :: v
    logical            :: tri_termine

    do
     tri_termine = .true.
     do i=2,n
       if ( v(i) > v(i-1) ) then
         tri_termine = .false.
         ! Utilisation de sections rgulires pour
         ! effectuer l'interversion.
         v(i-1:i) = v(i:i-1:-1)
       end if
     end do
     if (tri_termine) exit
    end do
  end subroutine tri_vecteur
end subroutine tri
