program tri_matrice
  implicit none
  integer, parameter   :: n=10, m=3
  real, dimension(n,m) :: mat
  integer              :: i, j
  character(len=8)     :: format="(  F7.3)"

  write( format(2:3), '(i2)' ) m
  ! Lecture de la matrice  trier.
  open( unit=1,              &
        file="exo6.matrice", &
        form="unformatted",  &
        status="old",        &
        action="read" )
  read( unit=1 ) mat
  close( unit=1 )

  call tri( mat, n, m ) ! Tri de la matrice lue.

  ! criture de la matrice trie.
  open( unit=1,           file="exo11.matrice_triee", &
        form="formatted", status="replace",           &
        action="write" )
  write( unit=1, fmt=format ) ((mat(i,j),j=1,m),i=1,n)
  close( unit=1 )
end program tri_matrice

                   ! Procdure de tri.
subroutine tri( mat, n, m )
  implicit none
  ! Dclaration des arguments
  integer              :: n, m
  real, dimension(n,m) :: mat
  ! Dclaration des variables locales
  integer              :: i, j

  do i=1,n      ! Tri des lignes.
    call tri_vecteur( mat(i,:), m )
  end do
  do j=1,m        ! Tri des colonnes.
    call tri_vecteur( mat(:,j), n )
  end do
  contains
              ! Procdure de tri d'un vecteur.
  subroutine tri_vecteur( v, nb_elts )
    integer                  :: nb_elts
    real, dimension(nb_elts) :: v
    integer                  :: i, j

    do i=nb_elts-1,1,-1
     do j=1,i
       if ( v(j) > v(j+1) ) then
         ! Utilisation de sections rgulires pour
         ! effectuer l'interversion.
         v(j:j+1) = v(j+1:j:-1)
       end if
     end do
    end do
  end subroutine tri_vecteur
end subroutine tri
